// SwfReaderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SwfReader.h"
#include "SwfReaderDlg.h"

#include "..\Swf\SwfData.h" 


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSwfReaderDlg dialog




CSwfReaderDlg::CSwfReaderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSwfReaderDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSwfReaderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSwfReaderDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BROWSE_SWF, &CSwfReaderDlg::OnBnClickedBrowseSwf)
END_MESSAGE_MAP()


// CSwfReaderDlg message handlers

BOOL CSwfReaderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CDialog::OnInitDialog();
	
	GetDlgItem(IDC_VERSION)->SetWindowTextW(_T("Version : ")); 
	GetDlgItem(IDC_MOVIE_SIZE)->SetWindowTextW(_T("Size: ")) ; 
	GetDlgItem(IDC_FRAME_RATE)->SetWindowTextW(_T("Frame rate: ")) ; 


	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSwfReaderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSwfReaderDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSwfReaderDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSwfReaderDlg::OnBnClickedBrowseSwf()
{
	TCHAR szFolder [MAX_PATH] ; 
	SHGetSpecialFolderPath(NULL,szFolder,CSIDL_PERSONAL,FALSE) ; 
	CString m_strCustPath = szFolder ; 
	
	static wchar_t  szFilter[] = _T("Flash (*.swf)  |*.swf;|") ; 
	CFileDialog dlg(TRUE,NULL,NULL,OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_EXPLORER ,szFilter,this) ; 
	dlg.m_ofn.lpstrInitialDir = m_strCustPath; 
	dlg.m_ofn.lpstrTitle = _T("Select flash swf file") ; 
	
	INT_PTR nResult =  dlg.DoModal();  

	if (nResult == IDOK) 
	{
		USES_CONVERSION ; 

		CString strFile = dlg.GetPathName() ;  
	
		SwfData data ; 
		if (data.ReadData(W2A((LPCTSTR)strFile))) 
		{
			CString strSize,strVersion,strFPS ; 
			int nWidth,nHeight ; 
			data.getMovieSize(&nWidth,&nHeight);
			
			strSize.Format(_T("Size: %d x %d"),nWidth,nHeight) ; 
			strVersion.Format(_T("Version : %d.0"),data.getVersion()) ; 
			strFPS.Format(_T("Frame rate: %d fps"),(int)data.getFrameRate());
		
			GetDlgItem(IDC_SWFPATH)->SetWindowTextW(strFile) ; 
			GetDlgItem(IDC_VERSION)->SetWindowTextW(strVersion) ; 
			GetDlgItem(IDC_MOVIE_SIZE)->SetWindowTextW(strSize) ; 
			GetDlgItem(IDC_FRAME_RATE)->SetWindowTextW(strFPS) ; 

		}
	}



}
